/* Generated by wayland-scanner 1.17.0 */

#ifndef QTAM_EXTENSION_SERVER_PROTOCOL_H
#define QTAM_EXTENSION_SERVER_PROTOCOL_H

#include <stdint.h>
#include <stddef.h>
#include "wayland-server-core.h"

#ifdef  __cplusplus
extern "C" {
#endif

struct wl_client;
struct wl_resource;

/**
 * @page page_qtam_extension The qtam_extension protocol
 * @section page_ifaces_qtam_extension Interfaces
 * - @subpage page_iface_qtam_extension - 
 * @section page_copyright_qtam_extension Copyright
 * <pre>
 *
 * Copyright (C) 2019 Luxoft Sweden AB
 * Copyright (C) 2018 Pelagicore AG
 * Contact: https://www.qt.io/licensing/
 *
 * This file is part of the Qt Application Manager.
 *
 * $QT_BEGIN_LICENSE:BSD-QTAS$
 * Commercial License Usage
 * Licensees holding valid commercial Qt Automotive Suite licenses may use
 * this file in accordance with the commercial license agreement provided
 * with the Software or, alternatively, in accordance with the terms
 * contained in a written agreement between you and The Qt Company.  For
 * licensing terms and conditions see https://www.qt.io/terms-conditions.
 * For further information use the contact form at https://www.qt.io/contact-us.
 *
 * BSD License Usage
 * Alternatively, you may use this file under the terms of the BSD license
 * as follows:
 *
 * "Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 * * Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * * Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in
 * the documentation and/or other materials provided with the
 * distribution.
 * * Neither the name of The Qt Company Ltd nor the names of its
 * contributors may be used to endorse or promote products derived
 * from this software without specific prior written permission.
 *
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
 *
 * $QT_END_LICENSE$
 *
 * SPDX-License-Identifier: BSD-3-Clause
 * </pre>
 */
struct qtam_extension;
struct wl_surface;

/**
 * @page page_iface_qtam_extension qtam_extension
 * @section page_iface_qtam_extension_api API
 * See @ref iface_qtam_extension.
 */
/**
 * @defgroup iface_qtam_extension The qtam_extension interface
 */
extern const struct wl_interface qtam_extension_interface;

/**
 * @ingroup iface_qtam_extension
 * @struct qtam_extension_interface
 */
struct qtam_extension_interface {
	/**
	 */
	void (*set_window_property)(struct wl_client *client,
				    struct wl_resource *resource,
				    struct wl_resource *surface,
				    const char *name,
				    struct wl_array *value);
};

#define QTAM_EXTENSION_WINDOW_PROPERTY_CHANGED 0

/**
 * @ingroup iface_qtam_extension
 */
#define QTAM_EXTENSION_WINDOW_PROPERTY_CHANGED_SINCE_VERSION 1

/**
 * @ingroup iface_qtam_extension
 */
#define QTAM_EXTENSION_SET_WINDOW_PROPERTY_SINCE_VERSION 1

/**
 * @ingroup iface_qtam_extension
 * Sends an window_property_changed event to the client owning the resource.
 * @param resource_ The client's resource
 */
static inline void
qtam_extension_send_window_property_changed(struct wl_resource *resource_, struct wl_resource *surface, const char *name, struct wl_array *value)
{
	wl_resource_post_event(resource_, QTAM_EXTENSION_WINDOW_PROPERTY_CHANGED, surface, name, value);
}

#ifdef  __cplusplus
}
#endif

#endif
